---  arm/arm/pmap.c.orig
+++  arm/arm/pmap.c
@@ -167,6 +167,7 @@
 #include <vm/vm_map.h>
 #include <vm/vm_page.h>
 #include <vm/vm_pageout.h>
+#include <vm/vm_reserv.h>
 #include <vm/vm_extern.h>
 #include <sys/lock.h>
 #include <sys/mutex.h>
@@ -197,8 +198,12 @@
 static void pmap_free_pv_entry (pv_entry_t);
 static pv_entry_t pmap_get_pv_entry(void);
 
+static int		pmap_fixup_l1_entry(pmap_t pm, vm_offset_t va);
+static void 		pmap_set_section(pmap_t pm, vm_offset_t va, vm_page_t m);
+static void 		pmap_remove_section(pmap_t pm, vm_offset_t va, vm_page_t m);
 static void		pmap_enter_locked(pmap_t, vm_offset_t, vm_page_t,
     vm_prot_t, boolean_t, int);
+static vm_paddr_t	pmap_extract_locked(pmap_t, vm_offset_t);
 static void		pmap_vac_me_harder(struct vm_page *, pmap_t,
     vm_offset_t);
 static void		pmap_vac_me_kpmap(struct vm_page *, pmap_t, 
@@ -211,10 +216,22 @@
 static int		pmap_clearbit(struct vm_page *, u_int);
 
 static struct l2_bucket *pmap_get_l2_bucket(pmap_t, vm_offset_t);
-static struct l2_bucket *pmap_alloc_l2_bucket(pmap_t, vm_offset_t);
+static struct l2_bucket *pmap_alloc_l2_bucket(pmap_t, vm_offset_t, int flags);
 static void		pmap_free_l2_bucket(pmap_t, struct l2_bucket *, u_int);
 static vm_offset_t	kernel_pt_lookup(vm_paddr_t);
 
+static void		pmap_promote_small(pmap_t, struct l2_bucket *, 
+    vm_offset_t);
+static void		pmap_promote_large(pmap_t, vm_offset_t va);
+static void		pmap_demote(pmap_t, vm_offset_t);
+static void		pmap_demote_large(pmap_t, vm_offset_t);
+
+static void 		pmap_nuke_pv(vm_page_t, pmap_t, struct pv_entry *);
+
+static void		pmap_enter_pv(vm_page_t, struct pv_entry *, pmap_t,
+    vm_offset_t, u_int);
+static struct pv_entry *pmap_remove_pv(vm_page_t, pmap_t, vm_offset_t);
+static u_int	pmap_modify_pv(vm_page_t, pmap_t, vm_offset_t, u_int, u_int);
 static MALLOC_DEFINE(M_VMPMAP, "pmap", "PMAP L1");
 
 vm_offset_t virtual_avail;	/* VA of first avail page (after kernel bss) */
@@ -280,6 +297,9 @@
 
 char *_tmppt;
 
+#ifdef ARM_USE_SMALL_ALLOC
+extern struct mtx smallalloc_mtx;
+#endif
 /*
  * Metadata for L1 translation tables.
  */
@@ -306,8 +326,13 @@
 
 	/* KVA of this L1 page table */
 	pd_entry_t *l1_kva;
+	struct mtx l1_mtx;
 };
 
+#define L1_LOCK(l1)		mtx_lock(&(l1)->l1_mtx)
+#define L1_UNLOCK(l1)		mtx_unlock(&(l1)->l1_mtx)
+#define PMAP_LOCK_L1(pmap)	L1_LOCK((pmap)->pm_l1)
+#define PMAP_UNLOCK_L1(pmap)	L1_UNLOCK((pmap)->pm_l1)
 /*
  * Convert a virtual address into its L1 table index. That is, the
  * index used to locate the L2 descriptor table pointer in an L1 table.
@@ -446,6 +471,8 @@
 		panic("pmap_init_l1: can't get PA of L1 at %p", l1pt);
 	SLIST_INSERT_HEAD(&l1_list, l1, l1_link);
 	TAILQ_INSERT_TAIL(&l1_lru_list, l1, l1_lru);
+	if (l1pt != pmap_kernel()->pm_l1->l1_kva)
+		mtx_init(&l1->l1_mtx, "L1 mtx", NULL, MTX_DEF | MTX_RECURSE);
 }
 
 static vm_offset_t
@@ -897,7 +924,7 @@
  * the bucket/page in the meantime.
  */
 static struct l2_bucket *
-pmap_alloc_l2_bucket(pmap_t pm, vm_offset_t va)
+pmap_alloc_l2_bucket(pmap_t pm, vm_offset_t va, int flags)
 {
 	struct l2_dtable *l2;
 	struct l2_bucket *l2b;
@@ -1070,6 +1097,8 @@
 	ptep = l2b->l2b_kva;
 	l2b->l2b_kva = NULL;
 
+	PMAP_LOCK_L1(pm);
+	pmap_fixup_l1_entry(pm, l1idx << L1_S_SHIFT);
 	pl1pd = &pm->pm_l1->l1_kva[l1idx];
 
 	/*
@@ -1081,6 +1110,7 @@
 		*pl1pd = 0;
 		PTE_SYNC(pl1pd);
 	}
+	PMAP_UNLOCK_L1(pm);
 
 	/*
 	 * Release the L2 descriptor table back to the pool cache.
@@ -1117,9 +1147,7 @@
 #ifndef PMAP_INCLUDE_PTE_SYNC
 	struct l2_bucket *l2b;
 	pt_entry_t *ptep, pte;
-#ifdef ARM_USE_SMALL_ALLOC
 	pd_entry_t *pde;
-#endif
 	vm_offset_t va = (vm_offset_t)mem & ~PAGE_MASK;
 
 	/*
@@ -1130,28 +1158,38 @@
 	 * page tables, we simply fix up the cache-mode here if it's not
 	 * correct.
 	 */
+	pde = &kernel_pmap->pm_l1->l1_kva[L1_IDX(va)];
 #ifdef ARM_USE_SMALL_ALLOC
-	pde = &kernel_pmap->pm_l1->l1_kva[L1_IDX(va)];
-	if (!l1pte_section_p(*pde)) {
+	if (l1pte_section_p(*pde) && va >= alloc_firstaddr)
+		return (0);
 #endif
+	if (l1pte_section_p(*pde) && (*pde & pte_l1_s_cache_mask) !=
+	    pte_l1_s_cache_mode_pt) {
+		pmap_demote_large(pmap_kernel(), va);
+		cpu_tlb_flushID_SE(va & L1_S_ADDR_MASK);
+	} else if (l1pte_section_p(*pde))
+		return (0);
+	
+	l2b = pmap_get_l2_bucket(pmap_kernel(), va);
+	ptep = &l2b->l2b_kva[l2pte_index(va)];
+	if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L && 
+	    (*ptep & L2_L_CACHE_MASK) != pte_l2_l_cache_mode_pt) {
+		pmap_demote(pmap_kernel(), va);
 		l2b = pmap_get_l2_bucket(pmap_kernel(), va);
-		ptep = &l2b->l2b_kva[l2pte_index(va)];
-		pte = *ptep;
+	}
+	pte = *ptep;
 		
-		if ((pte & L2_S_CACHE_MASK) != pte_l2_s_cache_mode_pt) {
-			/*
-			 * Page tables must have the cache-mode set to 
-			 * Write-Thru.
-			 */
-			*ptep = (pte & ~L2_S_CACHE_MASK) | pte_l2_s_cache_mode_pt;
-			PTE_SYNC(ptep);
-			cpu_tlb_flushD_SE(va);
-			cpu_cpwait();
-		}
-#ifdef ARM_USE_SMALL_ALLOC
+	if ((pte & L2_S_CACHE_MASK) != pte_l2_s_cache_mode_pt) {
+		/*
+		 * Page tables must have the cache-mode set to 
+		 * Write-Thru.
+		 */
+		*ptep = (pte & ~L2_S_CACHE_MASK) | pte_l2_s_cache_mode_pt;
+		PTE_SYNC(ptep);
+		cpu_tlb_flushD_SE(va);
+		cpu_cpwait();
 	}
 #endif
-#endif
 	memset(mem, 0, L2_TABLE_SIZE_REAL);
 	PTE_SYNC_RANGE(mem, L2_TABLE_SIZE_REAL / sizeof(pt_entry_t));
 	return (0);
@@ -1418,21 +1456,25 @@
 	struct pv_entry *pv, *npv;
 	struct l2_bucket *l2b;
 	pt_entry_t *ptep, pte;
+	vm_page_t m;
 	u_int entries = 0;
 	u_int writable = 0;
 	u_int cacheable_entries = 0;
 	u_int kern_cacheable = 0;
 	u_int other_writable = 0;
+	int had_large = 0, had_section = 0;
 
 	/*
 	 * Count mappings and writable mappings in this pmap.
 	 * Include kernel mappings as part of our own.
 	 * Keep a pointer to the first one.
 	 */
+count:
 	npv = TAILQ_FIRST(&pg->md.pv_list);
 	TAILQ_FOREACH(pv, &pg->md.pv_list, pv_list) {
 		/* Count mappings in the same pmap */
-		if (pm == pv->pv_pmap || kpmap == pv->pv_pmap) {
+		if (!(pv->pv_flags & (PVF_LARGE | PVF_SECTION)) &&
+		    (pm == pv->pv_pmap || kpmap == pv->pv_pmap)) {
 			if (entries++ == 0)
 				npv = pv;
 
@@ -1450,6 +1492,37 @@
 		if (pv->pv_flags & PVF_WRITE)
 			other_writable = 1;
 	}
+	/* Check if this page is part of a superpage. */
+	m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L1_S_FRAME);
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+		if (pv->pv_flags & PVF_SECTION) {
+			if (pv->pv_pmap == pm || pv->pv_pmap == kpmap) {
+				if ((pv->pv_flags & PVF_NC) == 0) {
+					had_section = 1;
+					cacheable_entries++;
+					if (kpmap == pv->pv_pmap)
+						kern_cacheable++;
+					if (pv->pv_flags & PVF_WRITE)
+						++writable;
+				}
+			}
+		}
+	}
+	m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L2_L_FRAME);
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+		if (pv->pv_flags & PVF_LARGE) {
+			if (pv->pv_pmap == pm || pv->pv_pmap == kpmap) {
+				if ((pv->pv_flags & PVF_NC) == 0) {
+					had_large = 1;
+					cacheable_entries++;
+					if (kpmap == pv->pv_pmap)
+						kern_cacheable++;
+					if (pv->pv_flags & PVF_WRITE)
+						++writable;
+				}
+			}
+		}
+	}
 
 	/*
 	 * Enable or disable caching as necessary.
@@ -1461,6 +1534,62 @@
 	    (entries > 0 && pm == kpmap && other_writable)) {
 		if (cacheable_entries == 0)
 			return;
+		/* Not optimal, but this won't happen very often. */
+		/* Demote any cached superpages. */
+		if (had_section) {
+			m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L1_S_FRAME);
+redo_tailq:
+			TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+				if (pv->pv_flags & PVF_SECTION) {
+					if (pv->pv_pmap == pm ||
+					    pv->pv_pmap == kpmap) {
+						if ((pv->pv_flags & PVF_NC)
+						    == 0) {
+							pmap_t pmap =
+							    pv->pv_pmap;
+							if (pmap != pm)
+								PMAP_LOCK(pmap);
+							PMAP_LOCK_L1(pmap);
+							pmap_fixup_l1_entry(pmap,
+							    pv->pv_va);
+							pmap_demote(pmap, 
+							    pv->pv_va);
+							PMAP_UNLOCK_L1(pmap);
+							if (pmap != pm)
+								PMAP_UNLOCK(pmap);
+							goto redo_tailq;
+						}
+					}
+				}
+			}
+		}
+
+		if (had_large) {
+			m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L2_L_FRAME);
+redo_tailq_large:
+			TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+				if (pv->pv_flags & PVF_LARGE) {
+					
+					if (pv->pv_pmap == pm ||
+					    pv->pv_pmap == kpmap) {
+						if ((pv->pv_flags & PVF_NC)
+						    == 0) {
+							pmap_t pmap =
+							    pv->pv_pmap;
+							if (pmap != pm)
+								PMAP_LOCK(pmap);
+							pmap_demote(pmap, 
+							    pv->pv_va);
+							if (pmap != pm)
+								PMAP_UNLOCK(pmap);
+							goto redo_tailq_large;
+						}
+					}
+				}
+			}
+		}
+		if (had_large || had_section)
+			goto count;
 
 		for (pv = npv; pv; pv = TAILQ_NEXT(pv, pv_list)) {
 			if ((pm != pv->pv_pmap && kpmap != pv->pv_pmap) ||
@@ -1468,8 +1597,18 @@
 				continue;
 
 			pv->pv_flags |= PVF_NC;
+			PMAP_LOCK_L1(pm);
+			pmap_fixup_l1_entry(pm, va);
 
+			if (l1pte_section_p(
+			    pm->pm_l1->l1_kva[L1_IDX(pv->pv_va)])) {
+				pmap_demote(pv->pv_pmap, pv->pv_va);
+				pmap_tlb_flushID_SE(pv->pv_pmap,
+				    pv->pv_va & L1_S_ADDR_MASK);
+			}
+			PMAP_UNLOCK_L1(pm);
 			l2b = pmap_get_l2_bucket(pv->pv_pmap, pv->pv_va);
+			
 			ptep = &l2b->l2b_kva[l2pte_index(pv->pv_va)];
 			pte = *ptep & ~L2_S_CACHE_MASK;
 
@@ -1524,11 +1663,459 @@
 
 			*ptep = pte;
 			PTE_SYNC_CURRENT(pv->pv_pmap, ptep);
+			if (pv->pv_flags & PVF_DEMOTED) {
+				pmap_t pmap = pv->pv_pmap;
+				vm_offset_t va = pv->pv_va;
+				PMAP_LOCK_L1(pmap);
+				pmap_promote_small(pmap, l2b, va);
+				pmap_promote_large(pmap, va);
+				PMAP_UNLOCK_L1(pmap);
+			}
 		}
 	}
 }
 
 /*
+ *
+ * pmap_find_pv: Find a pv entry
+ *
+ * => caller should hold lock on vm_page
+ */
+static PMAP_INLINE struct pv_entry *
+pmap_find_pv(struct vm_page *pg, pmap_t pm, vm_offset_t va)
+{
+	struct pv_entry *pv;
+	vm_page_t m;
+	
+	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
+	TAILQ_FOREACH(pv, &pg->md.pv_list, pv_list)
+	    if (pm == pv->pv_pmap && va == pv->pv_va)
+		    break;
+	/* Search a superpage PV entry. */
+	if (pv == NULL) {
+		m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L2_L_FRAME);
+		if (m != pg) {
+			TAILQ_FOREACH(pv, &m->md.pv_list, pv_list)
+			    if (pm == pv->pv_pmap && (va & L2_L_FRAME) == 
+				pv->pv_va)
+				    break;
+		}
+	}
+	if (pv == NULL) {
+		m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L1_S_FRAME);
+		if (m != pg) {
+			TAILQ_FOREACH(pv, &m->md.pv_list, pv_list)
+			    if (pm == pv->pv_pmap && (va & L1_S_FRAME) ==
+				pv->pv_va)
+				    break;
+		}
+	}
+	return (pv);
+}
+
+/* XXX: misleading, promote_small actually promotes to large pages. */
+static void
+pmap_promote_small(pmap_t pmap, struct l2_bucket *l2b, vm_offset_t va)
+{
+	int i;
+	pt_entry_t *ptep;
+	struct pv_entry *pv;
+	vm_page_t m;
+	vm_paddr_t pa0;
+	vm_offset_t va0;
+	int cachemode;
+	int oldwire = -1;
+	
+	ptep = &l2b->l2b_kva[l2pte_index(va & L2_L_FRAME)];
+	pa0 = *ptep & L2_L_FRAME;
+	va0 = va & L2_L_FRAME;
+	if ((*ptep & L2_S_FRAME) != pa0)
+		return;
+	/* First check it is eligible for promotion. */
+	for (i = 1; i < 0x10; i++) {
+		int wire1, wire2;
+		if (ptep[i] != (ptep[i - 1] + PAGE_SIZE)) {
+			/* There's no way we can do it. */
+			return;
+		}
+		pv = pmap_find_pv(PHYS_TO_VM_PAGE(ptep[i] & L2_S_FRAME), pmap,
+		    va0 + i * PAGE_SIZE);
+		if (!pv)
+			wire1 = -2;
+		else
+			wire1 = (pv->pv_flags & PVF_WIRED);
+		if (oldwire != -1 && wire1 != oldwire)
+			return;
+		pv = pmap_find_pv(PHYS_TO_VM_PAGE(ptep[i - 1] & L2_S_FRAME), 
+		    pmap, va0 + (i - 1) * PAGE_SIZE);
+		if (!pv)
+			wire2 = -2;
+		else
+			wire2 = (pv->pv_flags & PVF_WIRED);
+		if (wire1 != wire2)
+			return;
+		if (oldwire == -1)
+			oldwire = wire1;
+		
+	}
+#ifdef SP_DEBUG
+	printf("promoting small %x\n", va);
+#endif
+	if (*ptep & L2_S_PROT_U)
+		pa0 |= L2_L_PROT_U;
+	if (*ptep & L2_S_PROT_W)
+		pa0 |= L2_L_PROT_W;
+	/* Let's do it. */
+	if ((*ptep & pte_l2_s_cache_mask) == pte_l2_s_cache_mode)
+		cachemode = pte_l2_l_cache_mode;
+	else if ((*ptep & pte_l2_s_cache_mask) == pte_l2_s_cache_mode_pt)
+		cachemode = pte_l2_l_cache_mode_pt;
+	else
+		cachemode = 0;
+	for (i = 0; i < 0x10; i++) {
+		ptep[i] = pa0 | L2_L_PROTO | cachemode;
+		m = PHYS_TO_VM_PAGE(pa0 + i * PAGE_SIZE);
+		pv = pmap_find_pv(m, pmap, va0 + i * PAGE_SIZE);
+		if (pv) {
+			if (i == 0) {
+				pv->pv_flags |= PVF_LARGE;
+				pv->pv_flags &= ~PVF_DEMOTED;
+			} else {
+				pmap_nuke_pv(m, pmap, pv);
+				pmap_free_pv_entry(pv);
+			}
+		}
+	}
+}
+
+static void
+pmap_promote_large(pmap_t pmap, vm_offset_t va)
+{
+	pd_entry_t *pd;
+	pt_entry_t *pt;
+	vm_offset_t va0;
+	vm_paddr_t pa;
+	struct l2_dtable *l2;
+	struct l1_ttable *l1;
+	struct pv_entry *pv;
+	uint16_t l1idx;
+	int i;
+	int cachemode, cachemode2;
+	int oldwire = -1;
+	
+	va0 = va & L1_S_ADDR_MASK;
+	l1idx = L1_IDX(va0);
+	pd = &pmap->pm_l1->l1_kva[l1idx];
+	KASSERT(pd != NULL, ("NO pd_entry in pmap_promote_large"));
+	l2 = pmap->pm_l2[L2_IDX(l1idx)];
+	KASSERT(l2 != NULL, ("No l2 bucket in pmap_promote_large"));
+	pt = l2->l2_bucket[L2_BUCKET(l1idx)].l2b_kva;
+	KASSERT(pt != NULL, ("No pt in pmap_promote_large"));
+	if ((*pt & L2_TYPE_MASK) == L2_TYPE_L)
+		pa = *pt & L2_L_FRAME;
+	else
+		pa = *pt & L2_S_FRAME;
+	if (pa != (*pt & L1_S_FRAME))
+		return;
+	for (i = 1; i < 0x100; i++) {
+		vm_paddr_t pa, pa2;
+		int wire1, wire2;
+		int flags1 = 0, flags2 = 0;
+
+		if ((pt[i] & L2_TYPE_MASK) == L2_TYPE_L) {
+			pa = (pt[i] & L2_L_FRAME) + (i & 0xf) * PAGE_SIZE;
+			if ((pt[i] & pte_l2_l_cache_mask) == 
+			    pte_l2_l_cache_mode)
+				cachemode = pte_l1_s_cache_mode;
+			else if ((pt[i] & pte_l2_l_cache_mask) ==
+			    pte_l2_l_cache_mode_pt)
+				cachemode = pte_l1_s_cache_mode_pt;
+			else
+				cachemode = 0;
+			if (pt[i] & L2_L_PROT_U)
+				flags1 |= L2_S_PROT_U;
+			if (pt[i] & L2_L_PROT_W)
+				flags1 |= L2_S_PROT_W;
+		} else {
+			pa = pt[i] & L2_S_FRAME;
+			if ((pt[i] & pte_l2_s_cache_mask) == 
+			    pte_l2_s_cache_mode)
+				cachemode = pte_l1_s_cache_mode;
+			else if ((pt[i] & pte_l2_s_cache_mask) ==
+			    pte_l2_s_cache_mode_pt)
+				cachemode = pte_l1_s_cache_mode_pt;
+			else
+				cachemode = 0;
+			flags1 = pt[i] & (L2_S_PROT_U|L2_S_PROT_W);
+		}
+		if ((pt[i - 1] & L2_TYPE_MASK) == L2_TYPE_L) {
+			pa2 = (pt[i - 1] & L2_L_FRAME) +
+			    ((i - 1) & 0xf) * PAGE_SIZE;
+			if ((pt[i - 1] & pte_l2_l_cache_mask) == 
+			    pte_l2_l_cache_mode)
+				cachemode2 = pte_l1_s_cache_mode;
+			else if ((pt[i - 1] & pte_l2_l_cache_mask) ==
+			    pte_l2_l_cache_mode_pt)
+				cachemode2 = pte_l1_s_cache_mode_pt;
+			else
+				cachemode2 = 0;
+		if (pt[i - 1] & L2_L_PROT_U)
+			flags2 |= L2_S_PROT_U;
+		if (pt[i - 1] & L2_L_PROT_W)
+			flags2 |= L2_S_PROT_W;
+		} else {
+			pa2 = pt[i - 1] & L2_S_FRAME;
+			if ((pt[i - 1] & pte_l2_s_cache_mask) == 
+			    pte_l2_s_cache_mode)
+				cachemode2 = pte_l1_s_cache_mode;
+			else if ((pt[i - 1] & pte_l2_s_cache_mask) ==
+				pte_l2_s_cache_mode_pt)
+				cachemode2 = pte_l1_s_cache_mode_pt;
+			else
+				cachemode2 = 0;
+			flags2 = pt[i - 1] & (L2_S_PROT_U|L2_S_PROT_W);
+		}
+		if (pa != pa2 + PAGE_SIZE)
+			/* Nothing much we can do. */
+			return;
+		if (flags1 != flags2)
+			return;
+		if (cachemode != cachemode2)
+			return;
+		pv = pmap_find_pv(PHYS_TO_VM_PAGE(pa), pmap,
+		    va0 + i * PAGE_SIZE);
+		if (!pv)
+			wire1 = -2;
+		else
+			wire1 = (pv->pv_flags & PVF_WIRED);
+		if (oldwire != -1 && wire1 != oldwire)
+			return;
+		pv = pmap_find_pv(PHYS_TO_VM_PAGE(pa2), pmap,
+		    va0 + (i - 1) * PAGE_SIZE);
+		if (!pv)
+			wire2 = -2;
+		else
+			wire2 = (pv->pv_flags & PVF_WIRED);
+		if (wire1 != wire2)
+			return;
+		if (oldwire == -1)
+			oldwire = wire1;
+	}
+#ifdef SP_DEBUG
+	printf("promoting large %x\n", va);
+#endif
+	/* Now free the unused pts. */
+	if (*pt & L2_S_PROT_U)
+		pa |= L1_S_PROT_U;
+	if (*pt & L2_S_PROT_W)
+		pa |= L1_S_PROT_W;
+	*pd = L1_S_PROTO | pa | cachemode | L1_S_DOM(pmap->pm_domain);
+	bzero(pt, 0x100 * sizeof(*pt));
+	pmap_free_l2_bucket(pmap, &l2->l2_bucket[L2_BUCKET(l1idx)], 0x100);
+	if (pmap == kernel_pmap) {
+		SLIST_FOREACH(l1, &l1_list, l1_link) {
+			l1->l1_kva[l1idx] = *pd;
+			PTE_SYNC(&l1->l1_kva[l1idx]);
+		}
+	}
+	for (i = 1; i < 0x100; i++) {
+		pv = pmap_remove_pv(PHYS_TO_VM_PAGE((pa & L1_S_ADDR_MASK) +
+		    i * PAGE_SIZE), pmap, va0 + i * PAGE_SIZE);
+		if (pv)
+			/* 
+			 * It can happen that we don't find any pv, as it may
+			 * certainly was a large page before.
+			 */
+			pmap_free_pv_entry(pv);
+	}
+	if (oldwire != -2)
+		pmap_set_section(pmap, va0, 
+		    PHYS_TO_VM_PAGE(pa & L1_S_ADDR_MASK));
+}
+
+/* 
+ * Special case of pmap_demote(), where we know we want to demote a section
+ * mapping into large pages, except for the concerned page.
+ */
+
+static void
+pmap_demote_large(pmap_t pmap, vm_offset_t va)
+{
+	pd_entry_t *pd;
+	pt_entry_t *pt;
+	struct l2_bucket *l2b;
+	struct l1_ttable *l1;
+	struct pv_entry *pv;
+	vm_offset_t va0;
+	uint16_t l1idx;
+	vm_paddr_t pa;
+	int i, pv_flags;
+	int mode_l = 0, mode_s = 0;
+
+#ifdef SP_DEBUG
+	printf("demoting section mapping at %x\n", va);
+#endif
+	l1idx = L1_IDX(va);
+	pd = &pmap->pm_l1->l1_kva[l1idx];
+	va0 = va & L1_S_ADDR_MASK;
+	if (pmap == pmap_kernel())
+		l2b = pmap_get_l2_bucket(pmap, va0);
+	else
+		l2b = pmap_alloc_l2_bucket(pmap, va0, M_NOWAIT);
+	pa = *pd & L1_S_ADDR_MASK;
+	if (*pd & L1_S_PROT_U) {
+		mode_l |= L2_L_PROT_U;
+		mode_s |= L2_S_PROT_U;
+	}
+	if (*pd & L1_S_PROT_W) {
+		mode_l |= L2_L_PROT_W;
+		mode_s |= L2_S_PROT_W;
+	}
+	if ((*pd & pte_l1_s_cache_mask) == pte_l1_s_cache_mode) {
+		mode_l |= pte_l2_l_cache_mode;
+		mode_s |= pte_l2_s_cache_mode;
+	} else {
+		mode_l |= pte_l2_l_cache_mode_pt;
+		mode_s |= pte_l2_s_cache_mode_pt;
+	}
+	pt = &l2b->l2b_kva[l2pte_index(va0)];
+	*pd = l2b->l2b_phys | L1_C_DOM(pmap->pm_domain) | L1_C_PROTO;
+	l2b->l2b_occupancy += 0x100;
+	if (pmap == kernel_pmap) {
+		SLIST_FOREACH(l1, &l1_list, l1_link) {
+			l1->l1_kva[l1idx] = *pd;
+			PTE_SYNC(&l1->l1_kva[l1idx]);
+		}
+	}
+	pmap_remove_section(pmap, va0, PHYS_TO_VM_PAGE(pa & L1_S_ADDR_MASK));
+	pv = pmap_find_pv(PHYS_TO_VM_PAGE(pa), pmap, va0);
+	if (pv)
+		pv_flags = pv->pv_flags | PVF_DEMOTED;
+	else
+		pv_flags = 0;
+	for (i = 0; i < 0x100; i++, pa += PAGE_SIZE) {
+		if (va0 + i * PAGE_SIZE != va) {
+			if (pv_flags != 0) {
+				if (i != 0 && (i & 0xf) == 0)
+					pv = pmap_get_pv_entry();
+				if ((i & 0xf) == 0)
+					pmap_enter_pv(PHYS_TO_VM_PAGE(pa), pv,
+					    pmap, va0 + i * PAGE_SIZE,
+					    pv_flags | PVF_LARGE);
+			}
+			pt[i] = (pa & L2_L_FRAME) | mode_l;
+		} else {
+			if (pv_flags != 0) {
+				if (i != 0)
+					pv = pmap_get_pv_entry();
+				pmap_enter_pv(PHYS_TO_VM_PAGE(pa), pv,
+				    pmap, va0 + i * PAGE_SIZE, pv_flags);
+			}
+			if (pv_flags != 0) {
+				if (i != 0 && (i & 0xf) == 0)
+					pv = pmap_get_pv_entry();
+				if (i == 0)
+					pmap_modify_pv(PHYS_TO_VM_PAGE(pa),
+					    pmap, va0, PVF_LARGE | PVF_SECTION,
+					    PVF_LARGE);
+				else if ((i & 0xf) == 0)
+					pmap_enter_pv(PHYS_TO_VM_PAGE(pa), pv,
+					    pmap, va0 + i * PAGE_SIZE,
+					    pv_flags | PVF_LARGE);
+			}
+			pt[i] = pa | mode_s;
+		}
+	}
+}
+
+static void
+pmap_demote(pmap_t pmap, vm_offset_t va)
+{
+	pd_entry_t *pd;
+	pt_entry_t *pt;
+	struct l2_bucket *l2b;
+	struct l1_ttable *l1;
+	struct pv_entry *pv;
+	vm_offset_t va0;
+	uint16_t l1idx;
+	uint16_t demote_size;
+	vm_paddr_t pa;
+	int i;
+	int cachemode;
+	int pv_flags;
+
+#ifdef SP_DEBUG
+	printf("demoting %x\n", va);
+#endif
+	l1idx = L1_IDX(va);
+	pd = &pmap->pm_l1->l1_kva[l1idx];
+	if (l1pte_section_p(*pd)) {
+		va0 = va & L1_S_ADDR_MASK;
+		if (pmap == pmap_kernel())
+			l2b = pmap_get_l2_bucket(pmap, va0);
+		else
+			l2b = pmap_alloc_l2_bucket(pmap, va0, M_NOWAIT);
+		demote_size = 0x100;
+		pa = *pd & L1_S_ADDR_MASK;
+		if (*pd & L1_S_PROT_U)
+			pa |= L2_S_PROT_U;
+		if (*pd & L1_S_PROT_W)
+			pa |= L2_S_PROT_W;
+		if ((*pd & pte_l1_s_cache_mask) == pte_l1_s_cache_mode)
+			cachemode = pte_l2_s_cache_mode;
+		else
+			cachemode = pte_l2_s_cache_mode_pt;
+		pt = &l2b->l2b_kva[l2pte_index(va0)];
+		*pd = l2b->l2b_phys | L1_C_DOM(pmap->pm_domain) | L1_C_PROTO;
+		l2b->l2b_occupancy += 0x100;
+		if (pmap == kernel_pmap) {
+			SLIST_FOREACH(l1, &l1_list, l1_link) {
+				l1->l1_kva[l1idx] = *pd;
+				PTE_SYNC(&l1->l1_kva[l1idx]);
+			}
+		}
+		pmap_remove_section(pmap, va0, 
+		    PHYS_TO_VM_PAGE(pa & L1_S_ADDR_MASK));
+	} else {
+		va0 = va & L2_L_FRAME;
+		l2b = pmap_get_l2_bucket(pmap, va0);
+		demote_size = 0x10;
+		pt = &l2b->l2b_kva[l2pte_index(va0)];
+		if ((*pt & L2_TYPE_MASK) != L2_TYPE_L)
+			return;
+		pa = *pt & L2_L_FRAME;
+		if (*pt & L2_L_PROT_U)
+			pa |= L2_S_PROT_U;
+		if (*pt & L2_L_PROT_W)
+			pa |= L2_S_PROT_W;
+		if ((*pt & pte_l2_l_cache_mask) == pte_l2_l_cache_mode)
+			cachemode = pte_l2_s_cache_mode;
+		else
+			cachemode = pte_l2_s_cache_mode_pt;
+	}
+	pv = pmap_find_pv(PHYS_TO_VM_PAGE(pa), pmap, va0);
+	pa |= L2_S_PROTO;
+	if (pv)
+		pv_flags = (pv->pv_flags &~ PVF_LARGE) | PVF_DEMOTED;
+	else
+		pv_flags = 0;
+	for (i = 0; i < demote_size; i++, pa += PAGE_SIZE) {
+		if (pv_flags != 0) {
+			if (i != 0) {
+				pv = pmap_get_pv_entry();
+				pmap_enter_pv(PHYS_TO_VM_PAGE(pa), pv, pmap, 
+				    va0 + i * PAGE_SIZE, pv_flags);
+			} else
+				pmap_modify_pv(PHYS_TO_VM_PAGE(pa), pmap,
+				    va0, PVF_LARGE | PVF_SECTION, 0);
+		}
+		pt[i] = (pa) | cachemode;
+		PTE_SYNC(pt[i]);
+	}
+}
+
+
+/*
  * Modify pte bits for all ptes corresponding to the given physical address.
  * We use `maskbits' rather than `clearbits' because we're always passing
  * constants and the latter would require an extra inversion at run-time.
@@ -1538,6 +2125,7 @@
 {
 	struct l2_bucket *l2b;
 	struct pv_entry *pv;
+	vm_page_t m;
 	pt_entry_t *ptep, npte, opte;
 	pmap_t pm;
 	vm_offset_t va;
@@ -1551,6 +2139,37 @@
 	 */
 	pg->md.pvh_attrs &= ~(maskbits & (PVF_MOD | PVF_REF));
 
+	/* Check if we're part of a superpage. */
+	m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L1_S_FRAME);
+redo_tailq_section:
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+		if (pv->pv_flags & PVF_SECTION) {
+			if ((pv->pv_flags & (PVF_REF | PVF_WRITE)) &
+			    (maskbits & (PVF_REF | PVF_WRITE))) {
+				pm = pv->pv_pmap;
+				va = pv->pv_va;
+				PMAP_LOCK_L1(pm);
+				pmap_fixup_l1_entry(pm, va);
+				pmap_demote(pm, va);
+				PMAP_UNLOCK_L1(pm);
+				goto redo_tailq_section;
+			}
+		}
+	}
+	m = PHYS_TO_VM_PAGE(VM_PAGE_TO_PHYS(pg) & L2_L_FRAME);
+redo_tailq_large:
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list) {
+		if (pv->pv_flags & PVF_LARGE) {
+			if ((pv->pv_flags & (PVF_REF | PVF_WRITE)) &
+			    (maskbits & (PVF_REF | PVF_WRITE))) {
+				va = pv->pv_va;
+				pm = pv->pv_pmap;
+				pmap_demote(pm, va);
+				goto redo_tailq_large;
+			}
+		}
+	}
+
 	if (TAILQ_EMPTY(&pg->md.pv_list)) {
 		return (0);
 	}
@@ -1566,9 +2185,16 @@
 
 		PMAP_LOCK(pm);
 
+		PMAP_LOCK_L1(pm);
+		pmap_fixup_l1_entry(pm, va);
+
+		PMAP_UNLOCK_L1(pm);
 		l2b = pmap_get_l2_bucket(pm, va);
-
 		ptep = &l2b->l2b_kva[l2pte_index(va)];
+		if ((*ptep & L2_TYPE_MASK) == L2_TYPE_L) {
+			pmap_demote(pm, va);
+			pv->pv_flags |= PVF_DEMOTED;
+		}
 		npte = opte = *ptep;
 
 		if (maskbits & (PVF_WRITE|PVF_MOD)) {
@@ -1681,6 +2307,12 @@
 			if (PV_BEEN_REFD(oflags))
 				pmap_tlb_flushD_SE(pm, pv->pv_va);
 		}
+		if (pv->pv_flags & PVF_DEMOTED) {
+			PMAP_LOCK_L1(pm);
+			pmap_promote_small(pm, l2b, va);
+			pmap_promote_large(pm, va);
+			PMAP_UNLOCK_L1(pm);
+		}
 
 		PMAP_UNLOCK(pm);
 
@@ -1719,9 +2351,16 @@
 	pve->pv_pmap = pm;
 	pve->pv_va = va;
 	pve->pv_flags = flags;
+	pve->pv_page = pg;
 
 	TAILQ_INSERT_HEAD(&pg->md.pv_list, pve, pv_list);
-	TAILQ_INSERT_HEAD(&pm->pm_pvlist, pve, pv_plist);
+	if (pm->pm_firstpv)
+		TAILQ_INSERT_AFTER(&pm->pm_pvlist, pm->pm_firstpv,
+		    pve, pv_plist);
+	else {
+		TAILQ_INSERT_TAIL(&pm->pm_pvlist, pve, pv_plist);
+		pm->pm_firstpv = pve;
+	}
 	pg->md.pvh_attrs |= flags & (PVF_REF | PVF_MOD);
 	if (pm == pmap_kernel()) {
 		if (flags & PVF_WRITE)
@@ -1739,22 +2378,56 @@
 	vm_page_flag_set(pg, PG_REFERENCED);
 }
 
-/*
- *
- * pmap_find_pv: Find a pv entry
- *
- * => caller should hold lock on vm_page
- */
 static PMAP_INLINE struct pv_entry *
-pmap_find_pv(struct vm_page *pg, pmap_t pm, vm_offset_t va)
+pmap_find_superpage(pmap_t pm, vm_offset_t va)
+{
+	struct pv_entry *pv;
+
+	TAILQ_FOREACH(pv, &pm->pm_pvlist, pv_plist) {
+		if (!(pv->pv_flags & PVF_SECTION))
+			break;
+		if (pv->pv_va == va)
+			return (pv);
+	}
+	return (NULL);
+}
+
+/* Make it so all the section mappings are first in the pmap PV list. */
+
+static void 
+pmap_set_section(pmap_t pm, vm_offset_t va, vm_page_t m)
+{
+	struct pv_entry *pv;
+
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list)
+		if (pv->pv_va == va && pv->pv_pmap == pm)
+			break;
+	KASSERT(pv != NULL, ("No pv for new section"));
+	pv->pv_flags |= PVF_SECTION;
+	TAILQ_REMOVE(&pm->pm_pvlist, pv, pv_plist);
+	TAILQ_INSERT_HEAD(&pm->pm_pvlist, pv, pv_plist);
+}
+
+static void
+pmap_remove_section(pmap_t pm, vm_offset_t va, vm_page_t m)
 {
 	struct pv_entry *pv;
 
-	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
-	TAILQ_FOREACH(pv, &pg->md.pv_list, pv_list)
-	    if (pm == pv->pv_pmap && va == pv->pv_va)
-		    break;
-	return (pv);
+	TAILQ_FOREACH(pv, &m->md.pv_list, pv_list)
+		if (pv->pv_va == va && pv->pv_pmap == pm)
+			break;
+	/* We can ending up having no PV for unmanaged or fictitious pages. */
+	if (!pv)
+		return;
+	pv->pv_flags &= ~PVF_SECTION;
+	TAILQ_REMOVE(&pm->pm_pvlist, pv, pv_plist);
+	if (pm->pm_firstpv)
+		TAILQ_INSERT_AFTER(&pm->pm_pvlist, pm->pm_firstpv,
+		    pv, pv_plist);
+	else {
+		TAILQ_INSERT_TAIL(&pm->pm_pvlist, pv, pv_plist);
+		pm->pm_firstpv = pv;
+	}
 }
 
 /*
@@ -1792,11 +2465,15 @@
 static void
 pmap_nuke_pv(struct vm_page *pg, pmap_t pm, struct pv_entry *pve)
 {
+	struct pv_entry *tmppve;
 
 	mtx_assert(&vm_page_queue_mtx, MA_OWNED);
 	PMAP_ASSERT_LOCKED(pm);
 	TAILQ_REMOVE(&pg->md.pv_list, pve, pv_list);
+	tmppve = TAILQ_NEXT(pve, pv_plist);
 	TAILQ_REMOVE(&pm->pm_pvlist, pve, pv_plist);
+	if (pm->pm_firstpv == pve)
+		pm->pm_firstpv = tmppve;
 	if (pve->pv_flags & PVF_WIRED)
 		--pm->pm_stats.wired_count;
 	pg->md.pv_list_count--;
@@ -1843,6 +2520,22 @@
 
 	return(pve);				/* return removed pve */
 }
+
+static int
+pmap_clearbit_pv_range(pmap_t pm, vm_offset_t sva, vm_offset_t eva, int bits)
+{
+	struct pv_entry *pve;
+	int ret = 0;
+
+	TAILQ_FOREACH(pve, &pm->pm_pvlist, pv_plist) {
+		if (pve->pv_va >= sva && pve->pv_va < eva) {
+			ret |= pve->pv_flags;
+			pve->pv_flags &= ~bits;
+		}
+	}
+	return (ret);
+}
+
 /*
  *
  * pmap_modify_pv: Update pv flags
@@ -1985,16 +2678,38 @@
 {
 	struct l2_dtable *l2;
 	struct l2_bucket *l2b;
-	pd_entry_t *pl1pd, l1pd;
+	pd_entry_t *pl1pd;
 	pt_entry_t *ptep, pte;
 	vm_paddr_t pa;
 	u_int l1idx;
+	struct pv_entry *pv;
+	struct vm_page *pg;
 	int rv = 0;
 
 	l1idx = L1_IDX(va);
 	vm_page_lock_queues();
 	PMAP_LOCK(pm);
+	PMAP_LOCK_L1(pm);
+	rv = pmap_fixup_l1_entry(pm, va);
+	if (rv == 1) {
+		PMAP_UNLOCK_L1(pm);
+		goto out;
+	}
+	pl1pd = &pm->pm_l1->l1_kva[l1idx];
+	if (l1pte_section_p(*pl1pd)) {
+		if (user && !(*pl1pd & L1_S_PROT_U))
+			goto out;
+		pg = PHYS_TO_VM_PAGE((*pl1pd & L1_S_FRAME) + 
+		    (va & L1_S_OFFSET));
+		pv = pmap_find_pv(pg, pm, va);
+		if (!pv || (ftype == VM_PROT_WRITE &&
+		    !(pv->pv_flags & PVF_WRITE)))
+			goto out;
+		rv = 1;
+		goto out;
+	}
 
+	PMAP_UNLOCK_L1(pm);
 	/*
 	 * If there is no l2_dtable for this address, then the process
 	 * has no business accessing it.
@@ -2024,31 +2739,30 @@
 	/*
 	 * Catch a userland access to the vector page mapped at 0x0
 	 */
-	if (user && (pte & L2_S_PROT_U) == 0)
+	if (user && (((pte & L2_TYPE_MASK) == L2_TYPE_L &&
+	    (pte & L2_L_PROT_U) == 0) || (pte & L2_S_PROT_U) == 0))
 		goto out;
 	if (va == vector_page)
 		goto out;
 
-	pa = l2pte_pa(pte);
+	pa = (pte & L2_TYPE_MASK) == L2_TYPE_L ? 
+	    ((pte & L2_L_FRAME) | (va & L2_L_OFFSET)) : l2pte_pa(pte);
 
-	if ((ftype & VM_PROT_WRITE) && (pte & L2_S_PROT_W) == 0) {
+	if ((ftype & VM_PROT_WRITE) && (((pte & L2_TYPE_MASK) == L2_TYPE_L &&
+	    (pte & L2_L_PROT_W) == 0) || (pte & L2_S_PROT_W) == 0)) {
 		/*
 		 * This looks like a good candidate for "page modified"
 		 * emulation...
 		 */
-		struct pv_entry *pv;
-		struct vm_page *pg;
 
 		/* Extract the physical address of the page */
-		if ((pg = PHYS_TO_VM_PAGE(pa)) == NULL) {
+		if ((pg = PHYS_TO_VM_PAGE(pa)) == NULL)
 			goto out;
-		}
 		/* Get the current flags for this page. */
 
 		pv = pmap_find_pv(pg, pm, va);
-		if (pv == NULL) {
+		if (pv == NULL)
 			goto out;
-		}
 
 		/*
 		 * Do the flags say this page is writable? If not then it
@@ -2057,9 +2771,8 @@
 		 * PTE. Now we know a write has occurred we can correct this
 		 * and also set the modified bit
 		 */
-		if ((pv->pv_flags & PVF_WRITE) == 0) {
+		if ((pv->pv_flags & PVF_WRITE) == 0)
 			goto out;
-		}
 
 		pg->md.pvh_attrs |= PVF_REF | PVF_MOD;
 		vm_page_dirty(pg);
@@ -2072,8 +2785,14 @@
 		 * changing. We've already set the cacheable bits based on
 		 * the assumption that we can write to this page.
 		 */
-		*ptep = (pte & ~L2_TYPE_MASK) | L2_S_PROTO | L2_S_PROT_W;
+		*ptep = pte | L2_S_PROTO | L2_S_PROT_W;
 		PTE_SYNC(ptep);
+		if (pv->pv_flags & PVF_DEMOTED) {
+			PMAP_LOCK_L1(pm);
+			pmap_promote_small(pm, l2b, va);
+			pmap_promote_large(pm, va);
+			PMAP_UNLOCK_L1(pm);
+		}
 		rv = 1;
 	} else
 	if ((pte & L2_TYPE_MASK) == L2_TYPE_INV) {
@@ -2096,24 +2815,17 @@
 		pg->md.pvh_attrs |= PVF_REF;
 		pv->pv_flags |= PVF_REF;
 
-
 		*ptep = (pte & ~L2_TYPE_MASK) | L2_S_PROTO;
+		if (pv->pv_flags & PVF_DEMOTED) {
+			PMAP_LOCK_L1(pm);
+			pmap_promote_small(pm, l2b, va);
+			pmap_promote_large(pm, va);
+			PMAP_UNLOCK_L1(pm);
+		}
 		PTE_SYNC(ptep);
 		rv = 1;
 	}
 
-	/*
-	 * We know there is a valid mapping here, so simply
-	 * fix up the L1 if necessary.
-	 */
-	pl1pd = &pm->pm_l1->l1_kva[l1idx];
-	l1pd = l2b->l2b_phys | L1_C_DOM(pm->pm_domain) | L1_C_PROTO;
-	if (*pl1pd != l1pd) {
-		*pl1pd = l1pd;
-		PTE_SYNC(pl1pd);
-		rv = 1;
-	}
-
 #ifdef CPU_SA110
 	/*
 	 * There are bugs in the rev K SA110.  This is a check for one
@@ -2241,6 +2953,57 @@
 #endif
 }
 
+/* Fixup a L1 Section entry if it belongs to an another process. */
+static int
+pmap_fixup_l1_entry(pmap_t pm, vm_offset_t va)
+{
+	struct pv_entry *pv;
+	pd_entry_t *pl1pd;
+	u_int l1idx = L1_IDX(va);
+	int ret = 0;
+	
+	pl1pd = &pm->pm_l1->l1_kva[l1idx];
+	if (l1pte_section_p(*pl1pd) && (*pl1pd & L1_S_DOM_MASK) 
+	    == L1_S_DOM(pm->pm_domain))
+		return (0);
+	else if (l1pte_page_p(*pl1pd) && (*pl1pd & L1_C_DOM_MASK)
+	    == L1_C_DOM(pm->pm_domain))
+		return (0);
+	pv = pmap_find_superpage(pm, va & L1_S_ADDR_MASK);
+	if (pv) {
+		*pl1pd = VM_PAGE_TO_PHYS(pv->pv_page) |
+		    L1_S_PROTO | L1_S_PROT_U |
+		    pte_l1_s_cache_mode | L1_S_DOM(pm->pm_domain);
+		if (pv->pv_flags & PVF_WRITE)
+			*pl1pd |= L1_S_PROT_W;
+		PTE_SYNC(pl1pd);
+		pmap_tlb_flushID_SE(pm, va & L1_S_ADDR_MASK);
+		ret = 1;
+	} else {
+		struct l2_dtable *l2;
+		struct l2_bucket *l2b;
+		u_int l1idx;
+
+		
+		l1idx = L1_IDX(va);
+		l2 = pm->pm_l2[L2_IDX(l1idx)];
+		if (l2) {
+			l2b = &l2->l2_bucket[L2_BUCKET(l1idx)];
+			if (l2b && l2b->l2b_kva) {
+				*pl1pd = l2b->l2b_phys | 
+				    L1_C_DOM(pm->pm_domain) | L1_C_PROTO;
+				pmap_tlb_flushID_SE(pm, va);
+				ret = 1;
+			}
+		} 
+		PTE_SYNC(pl1pd);
+	}
+	if (l1pte_section_p(*pl1pd) && (*pl1pd & L1_S_DOM_MASK)
+		    != L1_S_DOM(pm->pm_domain))
+		*pl1pd = 0;
+	return (ret);
+}
+
 /*
  * This is used to stuff certain critical values into the PCB where they
  * can be accessed quickly from cpu_switch() et al.
@@ -2389,9 +3152,6 @@
  *	(physical) address starting relative to 0]
  */
 #define PMAP_STATIC_L2_SIZE 16
-#ifdef ARM_USE_SMALL_ALLOC
-extern struct mtx smallalloc_mtx;
-#endif
 
 void
 pmap_bootstrap(vm_offset_t firstaddr, vm_offset_t lastaddr, struct pv_addr *l1pt)
